# R2A OBSW [![pipeline status](https://git.skywarder.eu/r2a/skyward-boardcore/badges/master/pipeline.svg)](https://git.skywarder.eu/r2a/skyward-boardcore/commits/master)

*Software for Rocksanne2-Alpha*

This repository contains the On-Board Software for Rocksanne2-Alpha. 

To clone, use the `--recurse-submodules` option.

To build, use `sbs` (for more info, type `./sbs --help` on Linux or `sbs --help` on Windows).



## Folder Structure

| src/                   | sources!                                            |
| ---------------------- | --------------------------------------------------- |
| boards/                | Classes source files, divided per board.            |
| entrypoints/           | Each file here is a "*main*" to be built with SBS.  |
| tests/                 | Tests that can be built with SBS.                   |
| **skyward-boardcore/** | Provides the build system (SBS) and common drivers. |
| **bin/**               | Compiled binaries, to be flashed on boards.         |
| **build/**             | MIOSIX Makefiles generated by SBS (*not important*) |
| **obj/**               | Building stuff (*not important*)                    |

## Content

This repo contains software components that are specific to R2A. Please refer to [R2A-OBSW-SDD](https://docs.google.com/document/d/1ZR1zA4Dz7wDNBRiWThYC5OAfe9hZfSOdGBmbz2ConWU/edit) and [R2A-OBSW-SRS](https://docs.google.com/document/d/1yGYri5w8BWR6EBI6hym_Pu-zaps5E749E4Xsp1WGpJw/edit) documents for details.

The other common components (*EventBroker*, *Logger*, basic drivers etc...) are located in the `skyward-boardcore` repository, as well as the build system (SBS) and the operating system (MIOSIX). Please refer to that repo's documentation for more info.

The Ignition Board software is developed in a [dedicated repository](https://git.skywarder.eu/r2a/skyward-r2x-ignition), for safety reasons.

## Contributing

If you are developing new features, branch off from the `testing` branch and then merge back.